> For the complete documentation index, see [llms.txt](https://docs.digitalturbine.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.digitalturbine.com/dt-exchange/sdk-configuration/integrating-the-android-sdk/releasing-ad-instance-resources.md).

# Releasing Ad Instance Resources

After an ad shows, DT recommends releasing the resources used to show it. Releasing ad instance resources ensures efficient memory usage, prevents resource leaks, and supports proper lifecycle management.

Release the ad instance when:

* The app destroys the hosting screen or component.
* The ad no longer runs in the current session.
* The screen containing the ad is no longer visible.
* A new ad instance replaces the existing one.

The following example removes all views from the ad container and destroys the ad instance.

{% code title="Java" %}

```java
if (adContainer != null) {
  ​adContainer.removeAllViews();​
  adContainer = null;​
}​​
if (mSpot != null) {
  ​mSpot.destroy();​
  mSpot = null;​
}
```

{% endcode %}

{% code title="Kotlin" %}

```kotlin
adContainer?.removeAllViews()
adContainer = null

mSpot?.destroy()
mSpot = null
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.digitalturbine.com/dt-exchange/sdk-configuration/integrating-the-android-sdk/releasing-ad-instance-resources.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
